'   Areasort.bas - a program to sort the OPUS files.bbs
'   Requires a control file called AREASORT.CTL to be in
'   the c:\opus directory

DIM record$(300)
DIM filename$(300)
DIM index%(300)

CONST true = -1, false = 0
ON ERROR GOTO errorhandle

CLS
LOCATE 10, 10: PRINT "Files area sorting program"
LOCATE 11, 10: PRINT "Author: John Clarke"
LOCATE 12, 10: PRINT "Sysop PC Users Group"
LOCATE 13, 16: PRINT "IBM BBS  3:1211:2"
OPEN "c:\opus\areasort.ctl" FOR INPUT AS #1
DO UNTIL EOF(1)
  INPUT #1, pathname$
  filename1$ = pathname$ + "files.bak"
  filename2$ = pathname$ + "files.bbs"
  KILL filename1$
  NAME filename2$ AS filename1$
  OPEN filename1$ FOR INPUT AS #2
  OPEN filename2$ FOR OUTPUT AS #3
  LOCATE 15, 10: PRINT "Sorting "; filename2$; SPACE$(10)
  numrec% = 0
  DO UNTIL EOF(2)
    LINE INPUT #2, indata$
    IF LEFT$(indata$, 13) = "             " THEN
      record$(numrec%) = record$(numrec%) + CHR$(13) + CHR$(10) + indata$
      GOTO goround
    END IF
    IF LEFT$(indata$, 1) = " " THEN
      PRINT #3, indata$
      GOTO goround
    END IF
    numrec% = numrec% + 1
    in = false
    length% = LEN(indata$)
    record$(numrec%) = indata$
    FOR marker% = 1 TO length%
      c$ = MID$(indata$, marker%, 1)
      IF c$ <> " " AND c$ <> CHR$(9) THEN
        IF NOT in THEN
          in = true
        END IF
        filename$(numrec%) = filename$(numrec%) + c$
      ELSE
        in = false
        EXIT FOR
      END IF
    NEXT marker%
goround:
  LOOP
  FOR a% = 1 TO numrec%
    index%(a%) = a%
  NEXT a%

  n% = numrec%
beginnit:
  n% = INT(n% / 2)
  IF n% = 0 THEN GOTO endit
  k% = numrec% - n%
  j% = 1
middle:
  i% = j%
last:
  m% = i% + n%
  IF filename$(i%) > filename$(m%) THEN
    SWAP index%(i%), index%(m%)
    SWAP filename$(i%), filename$(m%)
    i% = i% - n%
    IF i% > 0 THEN GOTO last
  END IF
  j% = j% + 1
  IF j% > k% THEN GOTO beginnit
  GOTO middle
endit:
  FOR b% = 1 TO numrec%
    PRINT #3, record$(index%(b%))
    filename$(b%) = ""
  NEXT b%
  CLOSE #2, #3
LOOP
CLOSE #1
LOCATE 15, 18: PRINT "completed"; SPACE$(20)
END

CONST filenotfound = 53

errorhandle:
IF ERR = filenotfound THEN
  RESUME NEXT
ELSE
  ON ERROR GOTO 0
END IF

